﻿$engine JScript
$uname SnegopatMainScript
$dname Снегопат

// $engine - Имя скриптового движка, если его не получается определить по расширению файла
// $uname - уникальное имя аддина. Должно быть уникальным среди всех аддинов, для их поиска
//		по умолчанию - имя файла скрипта
// $dname - отображаемое имя аддина, для показа людям.
//		по умолчанию - имя файла скрипта
// В дальнейшем планируется:
// $addin УникальноеИмя ПодключаемоеИмя [global] - подключает объект аддина с указанным уникальным именем
// $nodebug - не присоединять скрипт к отладчику
// $form ПутьКФайлуФормы - загружает форму с подключением ее к скрипту

function loadStdScripts(path, group)
{
	// На NT-системах порядок выдачи файлов в FindFirstFile/FindNextFile неопределен, те они НЕОБЯЗАТЕЛЬНО
	// выдаются отсортированными по именам, поэтому на разных машинах могут выдаваться в разном порядке.
	// Кроме того, каталоги и файлы могут выдаваться вперемешку.
	// Также в документации к НайтиФайлы нет никакого упоминания о порядке выдачи файлов.
	// В случае зависимости одного стандартного скрипта от другого (например, snegopatwnd.js при
	// загрузке сразу обращается к global_context.js) это может привести к проблемам.
	// Поэтом примем такой порядок загрузки:
	// Сначала загружаются все подкатологи, отсортированные по имени.
	// Затем загржаются все файлы, отсортированные по имени.
	var folders = new Array()
	var files = new Array()
	for(var filesArray = new Enumerator(globalContext("{22A21030-E1D6-46A0-9465-F0A5427BE011}").НайтиФайлы(path, "*", false));
		!filesArray.atEnd(); filesArray.moveNext())
	{
		var file = filesArray.item();
		(file.ЭтоКаталог() ? folders : files).push(file)
	}

	function sortByNames(i1, i2)	{ return i1.Имя.toLowerCase().localeCompare(i2.Имя.toLowerCase()) }

	folders.sort(sortByNames)
	files.sort(sortByNames)
	for(var i in folders)
		loadStdScripts(folders[i].ПолноеИмя, group.addGroup(folders[i].Имя))
	for(var i in files)
	{
		var file = files[i]
		try{
			var a = addins.loadAddin("script:" + file.ПолноеИмя, group)
			SelfScript.addNamedItem(a.uniqueName, a.object)
		}catch(e)
		{
			Message("Ошибка при загрузке стандартного скрипта " + file.ПолноеИмя + ": " + e.description)
		}
	}
}

function loadAddinsFromIni(parentGroup, addinListGroup)
{
	// Создадим группу аддинов
	addinListGroup.group = parentGroup.addGroup(addinListGroup.name)
	// Для начала прогрузим все группы
	for(var i in addinListGroup.childs)
		loadAddinsFromIni(addinListGroup.group, addinListGroup.childs[i])
	// Теперь загрузим аддины
	for(var i in addinListGroup.addins)
	{
		var a = addinListGroup.addins[i]
		if(a.active)
		{
			try{
				a.addin = addins.loadAddin(a.uri, addinListGroup.group)
			}
			catch(e)
			{
				Message("Ошибка при загрузке аддина " + a.uri + ": " + e.description)
			}
		}
	}
}

function loadAddins()
{
	var mainFolder = profileRoot.getValue("Snegopat/MainFolder")
	// Для начала загрузим все скрипты из стандартной библиотеки Снегопата
	loadStdScripts(mainFolder + "core\\std\\scripts", addins.root.addGroup("Стандартные скрипты"))
	// Зарегим свои хоткеи
	hotkeys.registerAddinHotkeys(addins.byUniqueName(SelfScript.uniqueName))

    // Добавим группу для динамически подгружаемых библиотек.
    addins.root.addGroup("Подгружаемые библиотеки");
    
	// Теперь загрузим аддины, перечисленные в addins.ini
	var addinList = snegopatwnd.getAddinList(mainFolder + "addins.ini")
	loadAddinsFromIni(addins.root, addinList.root)
}

function createSnegopatWnd()
{
    snegopatwnd.getSnegopatWnd()
}

function initAll()
{
	// Первым делом проверим версию движка
    var engineVersion = parseFloat("" + ScriptEngineMajorVersion() + "." + ScriptEngineMinorVersion())
    if(engineVersion < 5.7)
    {
    	MessageBox("Плохая версия скриптового движка. Обновите JScript.", mbOk, "Снегопат", 5)
    	return
    }
    // Загрузим аддины
    loadAddins()
    // Создадим основное окно Снегопата
    createSnegopatWnd()
}

/*
 * Видимые людям макросы. Как макросы из скриптов видны методы без параметров, начинающиеся
 * с подстроки "macros". Сама подстрока из названия макроса убирается.
 */

function macrosВыбратьИВыполнитьМакрос()
{
	var macrosesWnd = addins.byUniqueName("macroswnd").object.getMacrosWnd()
	var res = macrosesWnd.selectMacros()
	if(res)
		addins.byUniqueName(res.addin).invokeMacros(res.macros)
}

function macrosНоваяФормаСкрипта()
{
	designScriptForm()
	MessageBox("При сохранении новой формы скрипта обязательно указывайте расширение файла .ssf, иначе 1С зависнет!!!",
		mbOk | mbIconInformation, "Снегопат", 5)
}

function macrosОткрытьФормуСкрипта()
{
	var selDlg = v8New("ДиалогВыбораФайла", v8New("ПеречислениеРежимДиалогаВыбораФайла").Открытие)
	selDlg.Заголовок = "Выберите файл формы скрипта"
	selDlg.ПолноеИмяФайла = ""
	selDlg.ПредварительныйПросмотр = false
	selDlg.Фильтр = "Формы скриптов (*.ssf)|*.ssf"

	if(selDlg.Выбрать())
		designScriptForm(selDlg.ПолноеИмяФайла)
}

function macrosОткрытьОкноСнегопата()
{
	snegopatwnd.getSnegopatWnd().form.Открыть()
}

function replaceSelInTxtWnd(textBefore, textAfter)
{
    var txtWnd = snegopat.activeTextWindow()
    if(!txtWnd)
        return false
    var oldText = txtWnd.selectedText
    var newText = textBefore
    if(textAfter.length)
        newText += oldText + textAfter
    txtWnd.selectedText = newText
    if(textAfter.length)
    {
        var cp = txtWnd.getCaretPos()
        txtWnd.setCaretPos(cp.beginRow, cp.beginCol - textAfter.length)
    }
    return true
}

// Маленький пример работы с командами и скриптом стандартных команд
function macrosЗакрытьОткрытьКонфигурацию()
{
	var state = stdcommands.Config.Close.getState()
	// Если  доступна команда закрытия конфигурации, значит она открыта. Закроем.
	if(state && state.enabled)
		return stdcommands.Config.Close.send()
	// Иначе - откроем
	return stdcommands.Config.Open.send()
}

function macrosПоказатьСписокМетодовМодуля()
{
    return snegopat.showMethodsList()
}

function macrosПоказатьВыпадающийСписокСнегопата()
{
    return snegopat.showSmartBox()
}

function macrosПерейтиКОпределению()
{
    if(snegopat.activeTextWindow())
    {
        var st = stdcommands.Frntend.GoToDefinition.getState()
        if(st && st.enabled)
            return stdcommands.Frntend.GoToDefinition.send()
    }
    return false
}

function macrosВернутьсяНазад()
{
    return stdcommands.Frame.GotoBack.send()
}

function macrosПерейтиВперед()
{
    return stdcommands.Frame.GotoForward.send()
}

function macrosПоказатьПараметры()
{
    return snegopat.showParams()
}

function macrosЛистатьПараметрыВперед()
{
    return snegopat.nextParams()
}

function macrosЛистатьПараметрыНазад()
{
    return snegopat.prevParams()
}

// Метод вызывается при регистрации хоткеев аддина
function getPredefinedHotkeys(predef)
{
    function addMacrosForInsert(textBefore, textAfter, hotKey)
    {
        var nameOfMacros = "Вставить " + textBefore
        if(textAfter.length)
            nameOfMacros += "..." + textAfter
        SelfScript.self["macros" + nameOfMacros] = new Function("return replaceSelInTxtWnd('" + textBefore + "', '" + textAfter + "')")
        if(hotKey)
            predef.add(nameOfMacros, hotKey)
    }
    predef.setVersion(3)
    predef.add("ПоказатьСписокМетодовМодуля", "Ctrl + 1|Ctrl + Alt + P")
    predef.add("ПоказатьВыпадающийСписокСнегопата", "Ctrl + Alt + Space")
    predef.add("ПерейтиКОпределению", "Ctrl + Enter")
    predef.add("ВернутьсяНазад", "Alt + Left")
    predef.add("ПерейтиВперед", "Alt + Right")
    predef.add("ПоказатьПараметры", "Ctrl + Shift + Space")
    predef.add("ЛистатьПараметрыВперед", "Alt + Down")
    predef.add("ЛистатьПараметрыНазад", "Alt + Up")
    addMacrosForInsert("<", "", "Alt + ,")
    addMacrosForInsert(">", "", "Alt + .")
    addMacrosForInsert("@", "", "Alt + 2")
    addMacrosForInsert("#", "", "Alt + 3")
    addMacrosForInsert("$", "", "Alt + 4")
    addMacrosForInsert("^", "", "Alt + 6")
    addMacrosForInsert("&", "", "Alt + 7")
    addMacrosForInsert("Null", "", "Alt + N")
    addMacrosForInsert("~", "", "Alt + ~")
    addMacrosForInsert("[", "]", "Alt + [")
    addMacrosForInsert("{", "}", "Alt + Shift + [")
    addMacrosForInsert("]", "", "Alt + ]")
    addMacrosForInsert("}", "", "Alt + Shift + ]")
    addMacrosForInsert("\\\'", "\\\'", "Alt + '")
    addMacrosForInsert("\\\"", "\\\"", "Alt + Shift + '")
    addMacrosForInsert("=", "", "Alt + =")
}

initAll()
