﻿$engine JScript
$uname stdlib
$dname Стандартная библиотека
$addin global
$addin stdcommands

global.connectGlobals(SelfScript)

DocKinds = {
    Auto:       '00000000-0000-0000-0000-000000000000', // Тип файла определяется по его расширению, если не найден, то как текст
    TextOem:    '74d75a51-58b7-46b0-931a-f3bac20e596e', // простой текст - кодировка Dos/Oem
    Epf:        '0e0e54cf-253b-4fc9-a895-26897e1a51f7', // обработки
    Erf:        '6d01520c-23c6-4301-86f7-e81268f07ee3', // отчеты
    Moxel:      'e555a6fe-768f-476a-bf4b-1d945aa56099', // табличный документ
    Config:     'c64ce8a4-a74d-40e9-996e-feadca885e11', // файл конфигурации
    Template:   '03ad782c-900b-4594-bdb7-66ed05992b8b'  // файл шаблонов
}

// Открыть файл для редактирования в 1С
// Если тип файла не задан, то используется Auto
function openFileIn1C(path, docKind)
{
    if(arguments.length < 2)    // docKind не указан
        docKind = DocKinds.Auto
    if(path.match(/\.ssf$/)) 
    {
        designScriptForm(path);
        return;
    }
    var mruItem = ЗначениеИзСтрокиВнутр('{"#",36973550-6bbb-11d5-bf72-0050bae2bc79,\n' +
    '{1,\n' +
    '{"file://' + path + '",0},' + docKind + '}\n' +
    '}')

    // Получим текущий список MRU из настроек
    var mru = profileRoot.getValue("App/MRUFileList")
    // Если там уже есть наше значение, удалим его
    var hasInMru = mru.НайтиПоЗначению(mruItem)
    if(hasInMru)
       mru.Удалить(hasInMru)
    // Если список полон, удалим последний элемент
    if(mru.Количество() == 8)
       mru.Удалить(7)
    // Вставим значение для нашего файла в начало списка
    mru.Вставить(0, mruItem)
    // Сохраним MRU-список обратно в настройки
    profileRoot.setValue("App/MRUFileList", mru)
    // И зашлем команду
    stdcommands.Frame.RecentFile.getState()
    stdcommands.Frame.RecentFile.send(0)
}

// Узнать, открыта ли конфигурация
function isConfigOpen()
{
    var s = stdcommands.Config.Close.getState()
    return s && s.enabled
}

// Узнать, модифицирована ли конфигурация
function isConfigModified()
{
    var s = stdcommands.Config.Save.getState()
    return s && s.enabled
}

// Узнать, отличается ли конфигурация от конфигурации ИБ
function isConfigsDifferent()
{
    var s = stdcommands.Config.UpdateDBCfg.getState()
    return s && s.enabled
}

// Загрузить скрипт-библиотеку по имени файла или полному пути.
function require(filename)
{
    var fullPath = filename;
    
    /* Задан полный путь или уникальное имя скрипта?
     * Проверяем по наличию указания буквы диска в начале пути 
     * или двойного слеша (при адресации скрипта на сетевом ресурсе).
     */
    
    var isFullPath = fullPath.match(/^(\w\:|\\\\)/);
    
    /* Если задано только имя файла, то ищем скрипт-библиотеку по имени файла 
     * в каталоге Scripts\Libs каталога Снегопата. 
     * TODO: Нужен ли "правильный" алгоритм поиска библиотеки, в рабочем каталоге 
     * и в путях, прописанных в переменной среды PATH?
     */
    
    if (!isFullPath)
    {
        var mainFolder = profileRoot.getValue("Snegopat/MainFolder");
        var f = v8New("Файл", mainFolder + "scripts\\Libs\\" + filename);
        
        if (!f.Существует() || !f.ЭтоФайл())
            throw "require: Не найден скрипт " + filename;
            
        fullPath = f.ПолноеИмя;
    }
     
    /* Формируем полный путь загрузки скрипта,
     * включающий в себя протокол.
     */
     
    var fullLoadString = "script:" + fullPath;
     
    /* Проверяем, не загружен ли скрипт уже (по полному пути) 
     * и загружаем, если это не так.
     */
    
    var lib = addins.byFullPath(fullLoadString);
    
    if (!lib)
    {
        /* Среди групп аддинов первого уровня ищем группу для 
         * скриптов-библиотек. Если такой группы нет, то создадим ее.
         */
        
        var libGroupName = "Подгружаемые библиотеки";        
        var libGroup = addins.root.child;               
        var libFound = false;
        
        while (libGroup)
        {
            if (libGroup.name == libGroupName)
            {
                libFound = true;
                break
            }
            
            libGroup = libGroup.next;
        }
        
        if (!libFound)
            libGroup = addins.root.addGroup(libGroupName);
            
        // Загружаем скрипт.
        try 
        {
            lib = addins.loadAddin(fullLoadString, libGroup);
        }
        catch(e)
        {
            Message("require: Скрипт-библиотека не загружен: " + fullPath);
            // Пробрасываем исключение наверх.
            throw e;
        }
    }
        
   return lib;
        
}






